Newer
Older
# Ganeti makefile
# - Indent with tabs only.
# - Keep files sorted; one line per file.
# - Directories in lib/ must have their own *dir variable (see hypervisor).
# - All directories must be listed DIRS.
# - Use autogen.sh to generate Makefile.in and configure script.
# Automake doesn't export these variables before version 1.10.
abs_top_builddir = @abs_top_builddir@
abs_top_srcdir = @abs_top_srcdir@
ACLOCAL_AMFLAGS = -I autotools
DOCBOOK_WRAPPER = $(top_srcdir)/autotools/docbook-wrapper
BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
CHECK_MAN = $(top_srcdir)/autotools/check-man
REPLACE_VARS_SED = autotools/replace_vars.sed
hypervisordir = $(pkgpythondir)/hypervisor
rapidir = $(pkgpythondir)/rapi
impexpddir = $(pkgpythondir)/impexpd
toolsdir = $(pkglibdir)/tools
docdir = $(datadir)/doc/$(PACKAGE)
# Delete output file if an error occurred while building it
.DELETE_ON_ERROR:
DIRS = \
autotools \
daemons \
devel \
doc \
doc/examples \
lib/confd \
lib/impexpd \
man \
qa \
scripts \
test \
test/data \
tools
BUILDTIME_DIRS = \
doc/api \
doc/coverage \
doc/html
DIRCHECK_EXCLUDE = \
$(BUILDTIME_DIRS) \
ganeti-[0-9]*.[0-9]*.[0-9]* \
doc/html/_*
$(addsuffix /*.py[co],$(DIRS)) \
autotools/replace_vars.sed \
daemons/daemon-util \
daemons/ganeti-cleaner \
doc/examples/bash_completion \
doc/examples/ganeti.initd \
doc/examples/ganeti.cron \
doc/examples/gnt-config-backup \
stamp-srclinks \
$(nodist_pkgpython_PYTHON)
stamp-srclinks \
stamp-directories \
nodist_pkgpython_PYTHON = \
lib/_autoconf.py
noinst_PYTHON = \
lib/build/__init__.py
pkgpython_PYTHON = \
lib/__init__.py \
lib/backend.py \
lib/bdev.py \
lib/bootstrap.py \
lib/cli.py \
lib/cmdlib.py \
lib/compat.py \
lib/config.py \
lib/constants.py \
lib/errors.py \
lib/jqueue.py \
lib/locking.py \
lib/luxi.py \
lib/mcpu.py \
lib/objects.py \
lib/opcodes.py \
lib/rpc.py \
lib/serializer.py \
lib/ssconf.py \
lib/ssh.py \
lib/storage.py \
hypervisor_PYTHON = \
lib/hypervisor/__init__.py \
lib/hypervisor/hv_base.py \
lib/hypervisor/hv_chroot.py \
lib/hypervisor/hv_fake.py \
lib/hypervisor/hv_xen.py
rapi_PYTHON = \
lib/rapi/__init__.py \
lib/rapi/client_utils.py \
lib/rapi/connector.py \
lib/rapi/rlib2.py
lib/http/__init__.py \
lib/http/auth.py \
lib/http/client.py \
lib/http/server.py
lib/confd/querylib.py \
lib/confd/server.py
lib/masterd/__init__.py \
lib/masterd/instance.py
impexpd_PYTHON = \
lib/impexpd/__init__.py
doc/move-instance.rst \
doc/html/.stamp: $(docrst) $(docpng) doc/conf.py configure.ac
@test -n "$(SPHINX)" || \
{ echo 'sphinx-build' not found during configure; exit 1; }
PYTHONPATH=. $(RUN_IN_TEMPDIR) $(SPHINX) -q -W -b html \
-D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
-D release="$(PACKAGE_VERSION)" \
$(abs_top_srcdir)/doc $(CURDIR)/doc/html
rm -f doc/html/.buildinfo doc/html/objects.inv
touch $@
doc/html: doc/html/.stamp
doc/news.rst: NEWS
set -e; \
{ echo '.. This file is automatically updated at build time from $<.'; \
echo '.. Do not edit.'; \
echo; \
cat $<; \
} > $@
doc/install-quick.rst: INSTALL
set -e; \
{ echo '.. This file is automatically updated at build time from $<.'; \
echo '.. Do not edit.'; \
echo; \
cat $<; \
} > $@
doc/arch-2.0.dot \
doc/design-2.1-lock-acquire.dot \
doc/design-2.1-lock-release.dot
docpng = $(patsubst %.dot,%.png,$(docdot))
# Things to build but not to install (add it to EXTRA_DIST if it should be
# distributed)
noinst_DATA = \
devel/upload \
doc/html \
doc/examples/bash_completion \
doc/examples/ganeti.cron \
doc/examples/ganeti.initd \
doc/examples/gnt-config-backup \
doc/examples/hooks/ipsec \
$(manhtml)
scripts/gnt-backup \
scripts/gnt-cluster \
scripts/gnt-debug \
scripts/gnt-instance \
scripts/gnt-job \
scripts/gnt-node \
scripts/gnt-os
dist_sbin_SCRIPTS = \
daemons/ganeti-noded \
daemons/ganeti-watcher \
daemons/ganeti-masterd \
daemons/ganeti-confd \
daemons/ganeti-rapi \
$(gnt_scripts)
nodist_sbin_SCRIPTS = \
daemons/ganeti-cleaner
dist_tools_SCRIPTS = \
tools/burnin \
tools/cfgshell \
tools/cfgupgrade \
pkglib_python_scripts = \
daemons/import-export \
tools/check-cert-expired
pkglib_SCRIPTS = \
autotools/build-bash-completion \
autotools/check-python-code \
autotools/docbook-wrapper \
autotools/gen-coverage \
daemons/daemon-util.in \
daemons/ensure-dirs.in \
daemons/ganeti-cleaner.in \
$(pkglib_python_scripts) \
$(docpng) \
$(docrst) \
doc/conf.py \
doc/html \
doc/examples/ganeti.initd.in \
doc/examples/ganeti.cron.in \
doc/examples/gnt-config-backup.in \
doc/examples/dumb-allocator \
doc/examples/ganeti.default \
doc/examples/ganeti.default-debug \
doc/examples/gnt-debug/README \
doc/examples/gnt-debug/delay0.json \
doc/examples/gnt-debug/delay50.json \
test/testutils.py \
test/mocks.py \
$(dist_TESTS) \
$(TEST_FILES) \
man/footer.sgml \
$(mansgml) \
$(maninput) \
qa/qa_cluster.py \
qa/qa_config.py \
qa/qa_daemon.py \
qa/qa_env.py \
qa/qa_error.py \
qa/qa_instance.py \
qa/qa_node.py \
qa/qa_os.py \
qa/qa_tags.py \
qa/qa_utils.py
man_MANS = \
man/ganeti.7 \
man/ganeti-noded.8 \
man/ganeti-os-interface.7 \
man/ganeti-watcher.8 \
man/gnt-backup.8 \
man/gnt-cluster.8 \
man/gnt-node.8 \
man/gnt-os.8
mansgml = $(patsubst %.7,%.sgml,$(patsubst %.8,%.sgml,$(man_MANS)))
manhtml = $(patsubst %.sgml,%.html,$(mansgml))
maninput = \
$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS))) \
$(patsubst %.html,%.html.in,$(manhtml))
TEST_FILES = \
test/data/bdev-both.txt \
test/data/bdev-disk.txt \
test/data/bdev-net.txt \
test/data/cert1.pem \
test/data/proc_drbd80-emptyline.txt \
test/data/proc_drbd83.txt \
test/import-export_unittest-helper
test/ganeti.backend_unittest.py \
test/ganeti.bdev_unittest.py \
test/ganeti.cli_unittest.py \
test/ganeti.cmdlib_unittest.py \
test/ganeti.compat_unittest.py \
test/ganeti.confd.client_unittest.py \
test/ganeti.config_unittest.py \
test/ganeti.constants_unittest.py \
test/ganeti.hooks_unittest.py \
test/ganeti.http_unittest.py \
test/ganeti.impexpd_unittest.py \
test/ganeti.locking_unittest.py \
test/ganeti.luxi_unittest.py \
test/ganeti.masterd.instance_unittest.py \
test/ganeti.objects_unittest.py \
test/ganeti.rapi.resources_unittest.py \
test/ganeti.rapi.rlib2_unittest.py \
test/ganeti.serializer_unittest.py \
test/ganeti.ssh_unittest.py \
test/ganeti.utils_unittest.py \
test/ganeti.workerpool_unittest.py \
test/docs_unittest.py \
test/tempfile_fork_unittest.py
test/check-cert-expired_unittest.bash \
test/ganeti-cleaner_unittest.bash \
test/import-export_unittest.bash \
nodist_TESTS =
TESTS = $(dist_TESTS) $(nodist_TESTS)
# Environment for all tests
PLAIN_TESTS_ENVIRONMENT = \
PYTHONPATH=. TOP_SRCDIR=$(abs_top_srcdir) PYTHON=$(PYTHON) $(RUN_IN_TEMPDIR)
# Environment for tests run by automake
$(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
$(dist_sbin_SCRIPTS) \
$(dist_tools_SCRIPTS) \
$(pkglib_python_scripts) \
$(pkgpython_PYTHON) \
$(hypervisor_PYTHON) \
$(rapi_PYTHON) \
$(http_PYTHON) \
$(confd_PYTHON) \
$(impexpd_PYTHON) \
$(noinst_PYTHON)
srclink_files = \
man/footer.sgml \
test/check-cert-expired_unittest.bash \
test/ganeti-cleaner_unittest.bash \
test/import-export_unittest.bash \
$(all_python_code)
check_python_code = \
$(BUILD_BASH_COMPLETION) \
$(all_python_code)
ganeti \
$(dist_sbin_SCRIPTS) \
$(dist_tools_SCRIPTS) \
$(pkglib_python_scripts) \
$(BUILD_BASH_COMPLETION)
test/daemon-util_unittest.bash: daemons/daemon-util
test/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
devel/upload: devel/upload.in $(REPLACE_VARS_SED)
sed -f $(REPLACE_VARS_SED) < $< > $@
chmod u+x $@
daemons/%: daemons/%.in \
$(REPLACE_VARS_SED)
sed -f $(REPLACE_VARS_SED) < $< > $@
doc/examples/%: doc/examples/%.in \
$(REPLACE_VARS_SED)
sed -f $(REPLACE_VARS_SED) < $< > $@
doc/examples/hooks/%: doc/examples/hooks/%.in \
$(REPLACE_VARS_SED)
sed -f $(REPLACE_VARS_SED) < $< > $@
doc/examples/bash_completion: $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
lib/cli.py $(gnt_scripts) tools/burnin
PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_BASH_COMPLETION) > $@
@test -n "$(DOT)" || { echo 'dot' not found during configure; exit 1; }
man/%.7.in man/%.8.in: man/%.sgml man/footer.sgml $(DOCBOOK_WRAPPER)
@test -n "$(DOCBOOK2MAN)" || \
{ echo 'docbook2man' not found during configure; exit 1; }
$(DOCBOOK_WRAPPER) "$(DOCBOOK2MAN)" $< $(notdir $(@:.in=)) $@
man/%.html.in: man/%.sgml man/footer.sgml $(DOCBOOK_WRAPPER)
@test -n "$(DOCBOOK2HTML)" || \
{ echo 'docbook2html' not found during configure; exit 1; }
$(DOCBOOK_WRAPPER) "$(DOCBOOK2HTML) --nochunks" $< $(notdir $(@:.in=)) $@
man/%.7: man/%.7.in $(REPLACE_VARS_SED)
man/%.8: man/%.8.in $(REPLACE_VARS_SED)
man/%.html: man/%.html.in $(REPLACE_VARS_SED)
lib/_autoconf.py: Makefile stamp-directories
set -e; \
{ echo '# This file is automatically generated, do not edit!'; \
echo '#'; \
echo ''; \
echo '"""Build-time configuration for Ganeti.'; \
echo '';\
echo 'This file is autogenerated by the build process.'; \
echo 'For any changes you need to re-run ./configure (and'; \
echo 'not edit by hand).'; \
echo ''; \
echo '"""'; \
echo ''; \
echo '# pylint: disable-msg=C0301,C0324'; \
echo '# because this is autogenerated, we do not want'; \
echo '# style warnings' ; \
echo ''; \
echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
echo "VERSION_FULL = '$(VERSION_FULL)'"; \
echo "LOCALSTATEDIR = '$(localstatedir)'"; \
echo "SYSCONFDIR = '$(sysconfdir)'"; \
echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
echo "XEN_INITRD = '$(XEN_INITRD)'"; \
echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
echo "ENABLE_FILE_STORAGE = $(ENABLE_FILE_STORAGE)"; \
echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
echo "SOCAT_PATH = '$(SOCAT)'"; \
echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
echo "TOOLSDIR = '$(toolsdir)'"; \
echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
echo "PKGLIBDIR = '$(pkglibdir)'"; \
echo "DRBD_BARRIERS = $(DRBD_BARRIERS)"; \
echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
echo "MASTERD_USER = '$(MASTERD_USER)'"; \
echo "RAPI_USER = '$(RAPI_USER)'"; \
$(REPLACE_VARS_SED): Makefile
set -e; \
{ echo 's#@PREFIX@#$(prefix)#g'; \
echo 's#@SYSCONFDIR@#$(sysconfdir)#g'; \
echo 's#@LOCALSTATEDIR@#$(localstatedir)#g'; \
echo 's#@SBINDIR@#$(sbindir)#g'; \
echo 's#@GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
echo 's#@CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
echo 's#@CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
echo 's#@CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
echo 's#@RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
echo 's#@RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
echo 's#@GNTMASTERUSER@#$(MASTERD_USER)#g'; \
echo 's#@GNTRAPIUSER@#$(RAPI_USER)#g'; \
echo 's#@GNTCONFDUSER@#$(CONFD_USER)#g'; \
echo 's#@GNTNODEDUSER@#$(NODED_USER)#g'; \
echo 's#@GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
echo 's#@GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
echo 's#@GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
echo 's#@GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
echo 's#@GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
} > $@
# We need to create symlinks because "make distcheck" will not install Python
# files when building.
stamp-srclinks: Makefile stamp-directories
for i in $(srclink_files); do \
if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
$(LN_S) $(abs_top_srcdir)/$$i $$i; \
fi; \
done
touch $@
cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
.PHONY: check-dirs
check-dirs: $(BUILT_SOURCES)
set -e; \
find . -type d \( \( -name . \) -o \( \
-name .git -o \
-name autom4te.cache \
\) -prune -o -print \) | { \
error=; \
while read dir; do \
case "$$dir" in \
$(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
*) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
esac; \
done; \
for dir in $(DIRS); do \
if ! test -d "$$dir"; then \
echo "Directory $$dir listed in DIRS does not exist" >&2; \
error=1; \
fi \
done; \
if test -n "$$error"; then exit 1; else exit 0; fi; \
}
check-local: check-dirs
$(CHECK_PYTHON_CODE) $(check_python_code)
lint: ganeti $(BUILT_SOURCES)
@test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
$(PYLINT) $(LINT_OPTS) $(lint_python_code)
# a dist hook rule for catching revision control directories
distcheck-hook:
if find $(top_distdir) -name .svn -or -name .git | grep .; then \
echo "Found revision control files in final archive." 1>&2; \
exit 1; \
fi
if find $(top_distdir) -name '*.py[co]' | grep .; then \
echo "Found Python byte code in final archive." 1>&2; \
exit 1; \
fi
if find $(top_distdir) -name '*~' | grep .; then \
echo "Found backup files in final archive." 1>&2; \
@mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
"$(DESTDIR)${localstatedir}/log/ganeti" \
"$(DESTDIR)${localstatedir}/run/ganeti"
stamp-directories: Makefile
@mkdir_p@ $(DIRS)
touch $@
apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(BUILT_SOURCES)
$(RUN_IN_TEMPDIR) epydoc -v \
--conf $(CURDIR)/epydoc.conf \
--output $(CURDIR)/doc/api
TAGS: $(BUILT_SOURCES)
rm -f TAGS
find . -path './lib/*.py' -o -path 'scripts/gnt-*' -o \
-path 'daemons/ganeti-*' -o -path 'tools/*' | \
etags -
.PHONY: coverage
coverage: $(BUILT_SOURCES) $(python_tests)
set -e; \
mkdir -p doc/coverage; \
COVERAGE_FILE=$(CURDIR)/doc/coverage/data \
TEXT_COVERAGE=$(CURDIR)/doc/coverage/report.txt \
HTML_COVERAGE=$(CURDIR)/doc/coverage \
$(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/gen-coverage \
$(python_tests)
-include ./Makefile.local